//
//  ClosestPair.java
//  ClosestPair
//
//  Created by Ed Hong on 1/26/06.
//  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
//
import java.util.*;
import java.awt.geom.*;
import java.io.*;

public class ClosestPair {

// This program runs the two closestpair algorithms on a 2D input from
// text file. The text input file format is a simple numbers
// separated by white space, x coordinate first.
    public static void main (String args[]) {
        // insert code here...
		Point2D.Double[] inputpoints;
		String inputfilename;

		// if you enter a command line argument, assume it's the filename of the
		// text file containing the input points; otherwise ask the user for the input filename.
		if (args.length >0) {
		  inputfilename = args[0];
		}
		else {
		  System.out.print("Enter file name for input points: ");
		  Scanner sc = new Scanner(System.in);
		  inputfilename = sc.next();
		}

		System.out.println("Reading input points from file " + inputfilename);
		inputpoints = readPoints(inputfilename);

// Debugging print statements
/*
		for(int i = 0; i < inputpoints.length; i++)
		  System.out.println(i + ") " + inputpoints[i]);
*/
		// call the closestPair algorithms & print results.

		System.out.println("Result from algorithm 1: " + closestPairAlg1(inputpoints));


		System.out.println("Result form algorithm 2: " +closestPairAlg2(inputpoints));
   }


	// Creates array of Point2D.Double read from the input filename.
	// returns array of points.
   public static Point2D.Double [] readPoints(String filename) {
	  Point2D.Double[] outputpoints;
	  Scanner sc;
	  try {
	     sc = new Scanner(new File (filename));
	  } catch (IOException e) {
	    System.out.println("Error reading file " + filename);
		return null;
	  }

	  // first create an ArrayList of points, so we don't have to
	  // worry about how many there are when reading the file.

	  ArrayList<Point2D.Double> temppoints = new ArrayList<Point2D.Double>();

      //loop for reading one point at a time.
	  while (sc.hasNextDouble()) {
	     double xval, yval;
		 xval = sc.nextDouble();
	     if (sc.hasNextDouble() == false)  {
		   System.out.println("Warning: last point has no y-coordinate; assigning y-coord of zero");
		   yval =0.0;
		 }
		 else yval = sc.nextDouble();
		 temppoints.add(new Point2D.Double(xval,yval));
	  }

//    Former debugging print statement.
//	  System.out.println(temppoints);

	  //convert the arraylist into an array of the right type, and return it.
	  // the input parameter to toArray makes sure the types are correct.
	  // let me know if you know a better way to do this..
	  outputpoints =  temppoints.toArray(new Point2D.Double[1]);
	  return outputpoints;
	}

// executes an algorithm for finding the closest-pair of its input points.
// Returns a single double representing the distance between the two
// closest points. Assume array size is at least 2.
   public static double closestPairAlg1(Point2D.Double [] inputpointset) {
     double mindistsq;

     mindistsq = inputpointset[0].distanceSq( inputpointset[1]);
	 int i,j;
	 for (i=1; i < inputpointset.length; i++) {
		 for (j=i+1; j< inputpointset.length; j++) {
		   double newdistsq = inputpointset[i].distanceSq(inputpointset[j]);
	       if (newdistsq < mindistsq)
	       	mindistsq = newdistsq;
	     }
	 }

     return Math.sqrt(mindistsq);
   }


// executes an algorithm for finding the closest-pair of its input points.
// Returns a single double representing the distance between the two
// closest points. Assume array size is at least 2.
   public static double closestPairAlg2(Point2D.Double [] inputpointset) {
     Arrays.sort(inputpointset, new CompareByXcoord());
     double mindist = recClosestPairAlg2(inputpointset, 0, inputpointset.length -1);
     return mindist;
   }

   // finds closestPair in the set inputpointset[p..q].
   // On input, assumes q>p, and that the points in inputpointset[p..q] are sorted by
   // x coordinate.
   // returns the distance between the two closest points, as a double.
   public static double recClosestPairAlg2(Point2D.Double [] inputpointset, int p, int q) {
       // handle base case(s) here.


       // for non-basecases, make your two recursive calls


       // Find points crossing split region that could be close together
       
       // figure out which points are in cleft


       // figure out which points are in cright


       // compare each point in cleft with each point in cright			   


       return 0;
   }

}

class CompareByXcoord implements Comparator<Point2D.Double> {
   public int compare( Point2D.Double P1, Point2D.Double P2) {
	   if (P1.x < P2.x) return -1;
	   if (P1.x > P2.x) return 1;
	   else return 0;
   }
   public boolean equals( Point2D.Double P1, Point2D.Double P2) {
	   return(P1.x == P2.x);
   }
}
